/***********************************************************************************************************************************
Cipher General Init and Free
***********************************************************************************************************************************/
#include <openssl/conf.h>
#include <openssl/evp.h>
#include <openssl/err.h>

#include "cipher/cipher.h"
#include "common/debug.h"

/***********************************************************************************************************************************
Flag to indicate if OpenSSL has already been initialized
***********************************************************************************************************************************/
static bool cipherInitDone = false;

/***********************************************************************************************************************************
Initialize ciphers
***********************************************************************************************************************************/
void
cipherInit()
{
    FUNCTION_DEBUG_VOID(logLevelTrace);

    if (!cipherInitDone)
    {
        ERR_load_crypto_strings();
        OpenSSL_add_all_algorithms();

        cipherInitDone = true;
    }

    FUNCTION_DEBUG_RESULT_VOID();
}

/***********************************************************************************************************************************
Have the ciphers been initialized?
***********************************************************************************************************************************/
bool
cipherIsInit()
{
    FUNCTION_TEST_VOID();
    FUNCTION_TEST_RESULT(BOOL, cipherInitDone);
}
